Bug 1047663 - workaround for clang not supporting --strict-build-id
Summary: workaround for clang not supporting --strict-build-id
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: rpm
Version: 20
Hardware: All
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Ville Skyttä
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-01-01 18:23 UTC by solanum
Modified: 2015-06-29 14:01 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-29 14:01:45 UTC
Type: Bug


Attachments (Terms of Use)
patch for find-debuginfo.sh (304 bytes, patch)
2014-01-01 18:23 UTC, solanum
no flags Details | Diff

Description solanum 2014-01-01 18:23:35 UTC
Created attachment 844180 [details]
patch for find-debuginfo.sh

Description of problem:

I was trying to rebuild packages with clang instead of gcc. Clang does not support --strict-build-id, for the debug files. Therefore there is no strict versioning information in the files. And the build stops trying to build the debugfiles. 

Version-Release number of selected component (if applicable):
rpm-build-4.11.1-7.fc20.x86_64

How reproducible:
every time. 

Steps to Reproduce:
1. try to use clang instead of gcc in mock. 


Actual results:

I am attaching a patch which if CC=clang then it essentially disables the --strict-build-id flag when using clang. It is easier then trying to fix the issue in the the SRPMS. 

I am not sure if it needs to be more robust for llvm, or look at the CXX flags too. Or whether a flag should be added to turn it off.  It is buried in the spec files for packages, and I would prefer not to change those. So it would have to be if both --strict-build-id and --no-strict-build-id are set, then it turns it off. 

After applying the patch it completes build in mock using clang.

Comment 1 solanum 2014-01-01 20:27:43 UTC
Moving to rpm since I realized rpm-build is part of that package. :) 

I should also note to get it to work under mock. I used: 

config_opts['files']['etc/profile.d/mystuff.sh'] = """
export CC=clang
export CXX=clang
export CFLAGS="-std=gnu89 -O3 -g -mstackrealign -Wall" 
# ...
"""


in my /etc/mock/fedora-20-x86_64.cfg file.

Comment 2 Fedora End Of Life 2015-05-29 10:16:40 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2015-06-29 14:01:45 UTC
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.